#from pyNN import *
#from pyNN.models import *
# cell assembly class for simple oscillator
#class Oscillator(pyNN.common):
from pyNN.nest import *

class Oscillator:
#default a .02, b .2, c -65, d 2.0, i_offset 0
	cell_params = {'a' : 0.05}
	name="default"
	size=5
	weight=6.0
	inh_weight=-5.25
	delay=1.0 #not required at this level, however, needed for connections. Tried to use parameter, d passed to methods.
	#constructor
	def __init__(self, x):
		self.size = x
		
	def __init__(self, n):
		self.name=n
	
#	def __init__(self):
		
	#get
	def getSize(self):
		return self.size
	def getOnePop(self):
		return self.pop1
	def getName(self):
		return self.name
	def getPop(self, x):
		if (x==1):
			return self.pop1
		else:
			return self.pop2
	def getWeight(self):
		return self.weight
	def getInhWeight(self):
		return self.inh_weight
	def getDelay(self):
		return self.delay
	#set connections
	#set
	def setSize(self, x):
		self.size = x
	
	def setCon(self, d):
		self.con1_2 = connect(self.pop1,self.pop2, weight=self.weight, delay=d)
		self.con2_1 = connect(self.pop2,self.pop1, weight=self.weight, delay=d)
	#set weight
	def setWeight(self, w):
		self.weight=w
	def setInhWeight(self, w):
		self.inh_weight = w

	#set population
	def setTwoPop(self):
		self.pop1 = Population(self.size,Izhikevich(**self.cell_params))
		self.pop2 = Population(self.size,Izhikevich(**self.cell_params))
		
	#set population for a single neuron/output 
	#this/self will not require internal connections
	def setOnePop(self):
		self.pop1 = Population(self.size, Izhikevich(**self.cell_params))

		
	def setOsc(self, d):
		if(self.getSize()==1):
			self.setOnePop()
			#no connections required in a population with single neuron
		else:
			self.setTwoPop()
			self.setCon(d)
			
		#self.setWeight()
	
	
		


class Module(Oscillator):
	number_of_modules=0
	MAX_Modules=4
	def __init__(self):
		Oscillator()
		self.number_of_modules+=1
	def __init__(self, n):
		Oscillator(n)
		self.number_of_modules+=1
	def getNumberOfModules(self):
		return self.number_of_modules
	def getMAX(self):
		return self.MAX_Modules
		
class Action(Oscillator):
	number_of_actions=0
	MAX_Actions=4
	def __init__(self):
		Oscillator()
		self.number_of_actions+=1
		self.setSize(1)
	def __init__(self,n):
		Oscillator(n)
		self.number_of_actions+=1
		self.setSize(1)
	def getPop(self):
		return self.getPop(1)
	def getMAX(self):
		return self.MAX_Actions
	def recordSpikes(self):
		self.getOnePop().record('spikes')
	def getNumberOfActions(self):
		return self.number_of_actions

class Fact(Oscillator):
	PulseDuration=10

	def __init__(self):
		Oscillator()
		self.setInhWeight(-4.5)
		self.setWeight(5.5)

	def __init__(self, n):
		Oscillator(n)
		self.setInhWeight(-4.5)
		self.setWeight(5.5)
	
	def injection(self,start_time):
		pulse=DCSource(amplitude=0.0055, start=start_time, stop=start_time+self.PulseDuration)
		pulse.inject_into(Assembly(self.pop1[0,1,2,3,4]))
	
		
class Goal(Oscillator):
	PulseDuration=10.0
	name=""
	number_of_goals=0
	MAX_Goals=4
	def __init__(self):
		Oscillator()
		self.number_of_goals+=1
		
	def __init__(self, n):
		Oscillator(n)
		self.number_of_goals+=1
	def getNumberOfGoals(self):
		return self.number_of_goals

	def getPulseDuration(self):
		return self.PulseDuration
	
	def setPulseDuration(self, x):
		self.PulseDuration = x
		
	def injection(self,start_time):
		pulse=DCSource(amplitude=0.0055, start=start_time, stop=start_time+self.getPulseDuration())
		pulse.inject_into(Assembly(self.pop1[0,1,2,3,4]))
	
	def recordSpikes(self):
		self.getPop
'''TR - Turn Right
TL - Turn Left
FW - Forward
BW - Backward
MR1 - Move Right 1 (compound statement)
MR2 - Move Right 2 
ML1 - Move Left 1 
ML2 - Move Left 2 
PYR - Pyramid
STAL - Stalactite
LEFT - left fact
RIGHT - Right fact
ERR - Error'''	
class Maes:
	goals=()
	goalsNotPrimed=()
	modules=()
	actions=()
	facts=()
	delay=1.0
	conGM11=[]
	conGM12=[]
	conGM21=[]
	conGM22=[]
	conGNPM11=[]
	conGNPM12=[]
	conGNPM21=[]
	conGNPM22=[]
	conMA1=[]
	conMA2=[]
	conAM1=[]
	conAM2=[]
	conAG1=[]
	conAG2=[]
	conAGNP1=[]
	conAGNP2=[]
	conGGNP1=[]
	conGGNP2=[]
	conFM1=[]
	conFM2=[]
	conFMG1=[]
	conFMG2=[]
	upper=0
	MAX_GOALS=4
	MAX_ACTIONS=5
	MAX_MODULES=4
	goalsList = ("TR","TL", "FW", "BW", "MR1", "ML1", "TO")
	goalsNPList=("MR2","ML2")
	modulesList = ("TR","TL", "FW", "BW", "MERR", "MTO")
	actionsList = ("TR", "TL", "FW", "BW", "AERR")
	factsList =  ("RIGHT", "LEFT", "PYR", "STAL")

	def __init__(self):
		injectionInterval=100
		currentTime=0
		self.upper=4
		#create the Goals
		self.TR = Goal("TR")	#turn right
		self.TL = Goal("TL")	#turn left
		self.FW = Goal("FW")	#forward
		self.BW = Goal("BW")	#backward
		self.MR1 = Goal("MR1") 	#move right - compound statement requires turn right followed by forward
		self.MR2 = Goal("MR2")	# move right - non primed
		self.ML1 = Goal("ML1") 	#move left - compound statement primed
		self.ML2 = Goal("ML2")	# move left - non primed
		self.TO	 = Goal("TO")	# towards object
		
		#facts
		self.RIGHT = Fact("RIGHT") 	#fact object on right
		self.LEFT = Fact("LEFT") 	#fact object on left
		self.PYR = Fact("PYR") 		#object pyramid fact
		self.STAL= Fact("STAL") 	#object stalactite fact

		#modules
		self.MTR = Module("TR")		#turn right
		self.MTL = Module("TL")		#turn left
		self.MFW = Module("FW")		#forward
		self.MBW = Module("BW")		#backward
		self.MERR= Module("MERR")	#error
		self.MTO = Module("TO")		#towards object - for this you require some facts.

		#actions
		self.ATR = Action("TR")		#turn right
		self.ATL = Action("TL")		#turn left
		self.AFW = Action("FW")		#forward
		self.ABW = Action("BW")		#backward
		self.AERR= Action("AERR")	#error
		#to access by name use lists below
		#e.g. modulesList.index("TL") accesses index[1]
		
		#save objects
		self.goals = (self.TR, self.TL, self.FW, self.BW, self.MR1, self.ML1, self.TO)
		self.goalsNotPrimed = (self.MR2, self.ML2)
		self.modules = (self.MTR, self.MTL, self.MFW, self.MBW, self.MERR, self.MTO)
		self.actions = (self.ATR, self.ATL, self.AFW, self.ABW, self.AERR)
		self.facts=(self.RIGHT, self.LEFT, self.PYR, self.STAL)

		#create 
		#sets up connections between goals 
		for g in self.goals:
			g.setOsc(self.delay)
			#g.injection(currentTime)
			#currentTime+=injectionInterval
		#set up connections between goalsNotPrimed
		for g in self.goalsNotPrimed:
			g.setOsc(self.delay)
		#sets up internal connections modules	
		for m in self.modules:
			m.setOsc(self.delay)
		#sets up internal connections actions
		for a in self.actions:
			a.setOsc(self.delay)
		#sets up internal connections facts
		for f in self.facts:
			f.setOsc(self.delay)

	def injectionTest3(self, interval):
		self.getFact( self.getIndexFactList("PYR")).injection(interval)
		self.getFact( self.getIndexFactList("RIGHT")).injection(interval)
		self.getFact( self.getIndexFactList("STAL")).injection(interval+100)
		self.getFact( self.getIndexFactList("RIGHT")).injection(interval+100)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+200)
		self.getFact( self.getIndexFactList("LEFT")).injection(interval+200)
		self.getFact( self.getIndexFactList("STAL")).injection(interval+300)
		self.getFact( self.getIndexFactList("LEFT")).injection(interval+300)
		self.getFact( self.getIndexFactList("STAL")).injection(interval+400)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+500)
	def injectionTest2(self, interval):
		self.getGoal( self.getIndexGoalList("TO")).injection(interval)
		#self.getFact( self.getIndexFactList("STAL")).injection(interval)
		#self.getFact( self.getIndexFactList("LEFT")).injection(interval)
		#self.getGoal( self.getIndexGoalList("TO")).injection(interval+100)
		#self.getFact( self.getIndexFactList("PYR")).injection(interval+100)
		#self.getGoal( self.getIndexGoalList("TR")).injection(interval)
		#self.getGoal( self.getIndexGoalList("ML1")).injection(interval+100)
		self.getGoal( self.getIndexGoalList("TL")).injection(interval+100)
		self.getGoal( self.getIndexGoalList("TR")).injection(interval+200)
		#self.getFact( self.getIndexFactList("RIGHT")).injection(interval+200)
		#self.getFact( self.getIndexFactList("STAL")).injection(interval+300)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+300)
		self.getFact( self.getIndexFactList("RIGHT")).injection(interval+300)
		self.getGoal( self.getIndexGoalList("TO")).injection(interval+300)
		
		self.getFact( self.getIndexFactList("PYR")).injection(interval+400)
		self.getFact( self.getIndexFactList("LEFT")).injection(interval+400)
		self.getGoal( self.getIndexGoalList("TO")).injection(interval+400)
		
		self.getGoal( self.getIndexGoalList("TL")).injection(interval+500)
		
		#self.getFact( self.getIndexFactList("STAL")).injection(interval+400)
		#self.getFact( self.getIndexFactList("PYR")).injection(interval+500)

	def injectionTestC(self, interval):
		self.getGoal( self.getIndexGoalList("TO")).injection(interval)
		
		self.getGoal( self.getIndexGoalList("TL")).injection(interval+100)
		self.getGoal( self.getIndexGoalList("TR")).injection(interval+200)
		
	def injectionTest1(self, interval):
		#DID INJECT GOALS IN AN ITERATION
		#easier to record and for others in a sequence
		self.getGoal( self.getIndexGoalList("TR")).injection(interval)
		self.getGoal( self.getIndexGoalList("TL") ).injection(interval+100)
		self.getGoal( self.getIndexGoalList("FW") ).injection(interval+200)
		self.getGoal( self.getIndexGoalList("BW") ).injection(interval+300)
		self.getGoal( self.getIndexGoalList("MR1") ).injection(interval+400)
		self.getGoal( self.getIndexGoalList("ML1")).injection(interval+500)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+600)
		self.getFact( self.getIndexFactList("RIGHT")).injection(interval+600)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+700)
		self.getFact( self.getIndexFactList("LEFT")).injection(interval+700)
		self.getFact( self.getIndexFactList("STAL")).injection(interval+800)
		self.getFact( self.getIndexFactList("RIGHT")).injection(interval+800)
		self.getFact( self.getIndexFactList("STAL")).injection(interval+900)
		self.getFact( self.getIndexFactList("LEFT")).injection(interval+900)
		self.getGoal( self.getIndexGoalList("TL") ).injection(interval+1000)
		self.getGoal( self.getIndexGoalList("FW") ).injection(interval+1100)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+1200)
		self.getGoal( self.getIndexGoalList("TR")).injection(interval+1200)
		self.getGoal( self.getIndexGoalList("TL")).injection(1300) 	
		self.getFact( self.getIndexFactList("LEFT")).injection(interval+1400)
		self.getFact( self.getIndexFactList("PYR")).injection(interval+1400)
		self.getGoal( self.getIndexGoalList("TL")).injection(1500) 
		
	#get 
	def getModules(self):
		return self.modules
	def getActions(self):
		return self.actions
	def getGoals(self):
		return self.goals
	def getDelay(self):
		return self.delay
	def getGoal(self,x):
		return self.goals[x]
	def getFact(self,x):
		return self.facts[x]
	def getAction(self,x):
		return self.actions[x]
	def getModule(self,x):
		return self.modules[x]
	def getIndexGoalList(self,x):
		return self.goalsList.index(x)
	def getIndexModuleList(self, x):
		return self.modulesList.index(x)
	def getIndexActionList(self, x):
		return self.actionsList.index(x)
	def getIndexFactList(self,x):
		return self.factsList.index(x)
	def getIndexGoalNPList(self,x):
		return self.goalsNPList.index(x)
	#set
	def setDelay(self, x):
		self.delay=x
	def print_Osc(self, o):
		for i in o:
			print "CA:"
			print i

	#set up connections
	#modifications: to well connected population 1 connected to population 2 etc..
	#just axed half the connections so that only population 1 & 2 in the pre-synaptic CA is connected to population 1 in the post-synaptic CA - still this does not work!! Axe a few more connections
	
	def ex_goal_module(self, i , j, coeff):
		ew = coeff*self.goals[i].getWeight()
		self.conGM11.append( connect(self.goals[i].getPop(1), self.modules[j].getPop(1), ew, self.delay) )
		self.conGM21.append( connect(self.goals[i].getPop(2), self.modules[j].getPop(1), ew, self.delay) )
		self.conGM22.append( connect(self.goals[i].getPop(2), self.modules[j].getPop(2), ew, self.delay) )
		self.conGM12.append( connect(self.goals[i].getPop(1), self.modules[j].getPop(2), ew, self.delay) )

	def ex_goalNP_module(self, i , j, coeff):
		ew = coeff * self.goalsNotPrimed[i].getWeight()
		self.conGNPM11.append( connect(self.goalsNotPrimed[i].getPop(1), self.modules[j].getPop(1), ew, self.delay) )
		self.conGNPM21.append( connect(self.goalsNotPrimed[i].getPop(2), self.modules[j].getPop(1), ew, self.delay) )
		self.conGNPM12.append( connect(self.goalsNotPrimed[i].getPop(1), self.modules[j].getPop(2), ew, self.delay) )
		self.conGNPM22.append( connect(self.goalsNotPrimed[i].getPop(2), self.modules[j].getPop(2), ew, self.delay) )
		
	def ex_module_action(self, i , j, coeff):
		ew = coeff * self.modules[i].getWeight()
		self.conMA1.append(connect(self.modules[i].getPop(1), self.actions[j].getOnePop(), ew, self.delay))
		self.conMA2.append(connect(self.modules[i].getPop(2), self.actions[j].getOnePop(), self.actions[j].getWeight(), self.delay))

	def ex_action_goalNP(self, i, j, coeff):
		ew = coeff * self.goalsNotPrimed[j].getWeight()
		self.conAGNP1.append(connect(self.actions[i].getOnePop(), self.goalsNotPrimed[j].getPop(1), ew, self.delay))
		#self.conAGNP2.append(connect(self.actions[i].getOnePop(), self.goalsNotPrimed[j].getPop(2), ew, self.delay))

	def ex_goal_goalNP(self, i, j, coeff):
		ih=coeff*self.goals[i].getWeight()
		self.conGGNP1.append(connect(self.goals[i].getPop(1), self.goalsNotPrimed[j].getPop(1), ih, self.delay))
		self.conGGNP2.append(connect(self.goals[i].getPop(2), self.goalsNotPrimed[j].getPop(1), ih, self.delay))
	
	def ex_fact_module(self, i, j, coeff):
		ew = coeff*self.facts[i].getWeight()
		self.conFM1.append(connect(self.facts[i].getPop(1), self.modules[j].getPop(1), ew, self.delay))
		self.conFM2.append(connect(self.facts[i].getPop(2), self.modules[j].getPop(1), ew, self.delay ))
		#self.conFM1.append(connect(self.facts[i].getPop(1), self.modules[j].getPop(2), ew, self.delay))
		#self.conFM2.append(connect(self.facts[i].getPop(2), self.modules[j].getPop(2), ew, self.delay ))
		
	def inh_action_module(self, i, j):
		self.conAM1.append(connect(self.actions[i].getOnePop(), self.modules[j].getPop(1), self.actions[i].getInhWeight(), self.delay))
		self.conAM2.append(connect(self.actions[i].getOnePop(), self.modules[j].getPop(2), self.actions[i].getInhWeight(), self.delay))
	def inh_action_module(self, i, j, coeff):
		iw = coeff * self.modules[j].getInhWeight()
		self.conAM1.append(connect(self.actions[i].getOnePop(), self.modules[j].getPop(1), iw, self.delay))
		self.conAM2.append(connect(self.actions[i].getOnePop(), self.modules[j].getPop(2), iw, self.delay))
	
	def inh_action_goal(self, i, j, coeff):
		iw = coeff * self.goals[j].getInhWeight()
		self.conAG1.append(connect(self.actions[i].getOnePop(), self.goals[j].getPop(1), iw, self.delay ))
		self.conAG2.append(connect(self.actions[i].getOnePop(), self.goals[j].getPop(2), iw, self.delay))
		
	def inh_action_goalNP(self, i, j, coeff):
		iw = coeff * self.goalsNotPrimed[j].getInhWeight()
		self.conAGNP1.append(connect(self.actions[i].getOnePop(), self.goalsNotPrimed[j].getPop(1), self.goalsNotPrimed[j].getInhWeight(), self.delay ))
		self.conAGNP2.append(connect(self.actions[i].getOnePop(), self.goalsNotPrimed[j].getPop(2), self.goalsNotPrimed[j].getInhWeight(), self.delay ))
	
	def inh_fact_module(self, i, j, coeff):
		iw = coeff * self.modules[j].getInhWeight()
		self.conFM1.append(connect(self.facts[i].getPop(1), self.modules[j].getPop(1), iw, self.delay))
		self.conFM1.append(connect(self.facts[i].getPop(1), self.modules[j].getPop(2), iw, self.delay))
		self.conFM2.append(connect(self.facts[i].getPop(2), self.modules[j].getPop(1), iw, self.delay))
		self.conFM2.append(connect(self.facts[i].getPop(2), self.modules[j].getPop(2), iw, self.delay))
		
		
	def inh_action_fact(self, i, j, coeff):
		iw = coeff*self.facts[j].getInhWeight()
		self.conAG1.append(connect(self.actions[i].getOnePop(), self.facts[j].getPop(1), iw, self.delay))
		self.conAG2.append(connect(self.actions[i].getOnePop(), self.facts[j].getPop(2), iw, self.delay))
	
	def network(self):
		self.ex_goal_module(self.getIndexGoalList("TR"), self.getIndexModuleList("TR"), 1.0)
		self.ex_goal_module(self.getIndexGoalList("TL"), self.getIndexModuleList("TL"), 1.0)
		self.ex_goal_module(self.getIndexGoalList("FW"), self.getIndexModuleList("FW"), 1.0)
		self.ex_goal_module(self.getIndexGoalList("BW"), self.getIndexModuleList("BW"), 1.0)
		self.ex_goal_module(self.getIndexGoalList("MR1"),self.getIndexModuleList("TR"), 0.75)
		self.ex_goal_module(self.getIndexGoalList("ML1"),self.getIndexModuleList("TL"), 0.75)

		self.ex_module_action(self.getIndexModuleList("TR"), self.getIndexActionList("TR"), 0.8)
		self.ex_module_action(self.getIndexModuleList("TL"), self.getIndexActionList("TL"), 0.8)
		self.ex_module_action(self.getIndexModuleList("FW"), self.getIndexActionList("FW"), 0.8)
		self.ex_module_action(self.getIndexModuleList("BW"), self.getIndexActionList("BW"), 0.8)

		self.ex_goalNP_module(self.getIndexGoalNPList("MR2"), self.getIndexModuleList("FW"),0.5)
		self.ex_goalNP_module(self.getIndexGoalNPList("ML2"), self.getIndexModuleList("FW"),0.5)

		self.ex_goal_goalNP( self.getIndexGoalList("MR1"), self.getIndexGoalNPList("MR2"), 0.75 )
		self.ex_goal_goalNP( self.getIndexGoalList("ML1"), self.getIndexGoalNPList("ML2"), 0.75 )		

		self.inh_action_goal( self.getIndexActionList("TR"), self.getIndexGoalList("TR"), 1.55)
		self.inh_action_goal( self.getIndexActionList("TL"), self.getIndexGoalList("TL"), 1.55)
		self.inh_action_goal( self.getIndexActionList("FW"), self.getIndexGoalList("FW"), 1.5)
		self.inh_action_goal( self.getIndexActionList("BW"), self.getIndexGoalList("BW"), 1.5)
		
		self.inh_action_module( self.getIndexActionList("TR"), self.getIndexModuleList("TR"), 1.0)
		self.inh_action_module( self.getIndexActionList("TL"), self.getIndexModuleList("TL"), 1.0)
		self.inh_action_module( self.getIndexActionList("FW"), self.getIndexModuleList("FW"), 1.0)
		self.inh_action_module( self.getIndexActionList("BW"), self.getIndexModuleList("BW"), 1.0)
		
		self.inh_action_goal( self.getIndexActionList("TR"), self.getIndexGoalList("MR1"), 0.8)
		self.inh_action_goal( self.getIndexActionList("TL"), self.getIndexGoalList("ML1"), 0.8)

		self.inh_action_goalNP( self.getIndexActionList("FW"), self.getIndexGoalNPList("MR2"), 0.8)
		self.inh_action_goalNP( self.getIndexActionList("FW"), self.getIndexGoalNPList("ML2"), 0.8)

		self.ex_action_goalNP( self.getIndexActionList("TR"), self.getIndexGoalNPList("MR2"),0.85)
		self.ex_action_goalNP( self.getIndexActionList("TL"), self.getIndexGoalNPList("ML2"),0.85)
		
		self.ex_goal_module( self.getIndexGoalList("TO"), self.getIndexModuleList("TR"), 0.3)
		self.ex_goal_module( self.getIndexGoalList("TO"), self.getIndexModuleList("TL"), 0.3)
		
		self.inh_action_goal( self.getIndexActionList("TR"), self.getIndexGoalList("TO"), 1.5)
		self.inh_action_goal( self.getIndexActionList("TL"), self.getIndexGoalList("TO"), 1.5)
		
		
	def networkFacts(self):
		#facts and modules
		self.ex_fact_module( self.getIndexFactList("RIGHT"), self.getIndexModuleList("TR"), 0.15)
		self.ex_fact_module( self.getIndexFactList("LEFT"), self.getIndexModuleList("TL"), 0.15)
		#self.inh_fact_module( self.getIndexFactList("RIGHT"), ,3.0)
		#stalactite
		self.ex_fact_module( self.getIndexFactList("STAL"),self.getIndexModuleList("TL"),0.15)
		self.ex_fact_module( self.getIndexFactList("STAL"),self.getIndexModuleList("TR"),0.15)
		#Objects (PYRAMID) and modules
		self.ex_fact_module( self.getIndexFactList("PYR"),self.getIndexModuleList("TL"),0.15)
		self.ex_fact_module( self.getIndexFactList("PYR"),self.getIndexModuleList("TR"),0.15)
		
		#facts inhibit modules
		#tricky - inhibition from action and fact can cause spiking
		self.inh_fact_module( self.getIndexFactList("RIGHT"), self.getIndexModuleList("TL"),0.5)
		self.inh_fact_module( self.getIndexFactList("LEFT"), self.getIndexModuleList("TR"),0.5)
		
		
		
		
		
	def networkError(self):	


		self.ex_goal_module( self.getIndexGoalList("TO"), self.getIndexModuleList("MERR"), 0.85)
		
		self.inh_fact_module( self.getIndexFactList("LEFT"), self.getIndexModuleList("MERR"), 0.5)
		self.inh_fact_module( self.getIndexFactList("RIGHT"), self.getIndexModuleList("MERR"), 0.5)
		self.inh_fact_module( self.getIndexFactList("STAL"), self.getIndexModuleList("MERR"), 0.5)
		self.inh_fact_module( self.getIndexFactList("PYR"), self.getIndexModuleList("MERR"), 0.5)
		
		#network facts (object but no direction) and errors - excitatory
		self.ex_module_action( self.getIndexModuleList("MERR"), self.getIndexActionList("AERR"), 0.9)
		
		#network facts and errors - inhibitory
		self.inh_action_module( self.getIndexActionList("AERR"), self.getIndexModuleList("MERR"), 1.0)
		self.inh_action_goal(self.getIndexActionList("AERR"), self.getIndexGoalList("TO"), 1.0)
		
		
	def getChrisFact(self,name):
		theFactIndex = self.getIndexFactList(name)
		return self.facts[theFactIndex].getPop(1)
