"""
Connections from the Retina to V1
The hEdgeBottom, sEdgeLeft, bEdgeRight, andAngle, lessThanAngle,
greaterThanAngle, HedgeTop, sEdgeRight, bEdgeLeft and orAngle
Connection Functions
"""

INPUT_NEURONS_HEIGHT = 50
INPUT_NEURONS_WIDTH = 50

DELAY = 1.0

#----------setup connections 6x6 on to HEdgeBottom (bottom of a solid)
#Two on either side and self, self and below, inhib two below (10,5)
def set6x6OnToHEdgeTopConnections(Col,Row):
    weight = 3.0
    inhibWeight = -3.0
    #don't output off bottom
    if (Row >= INPUT_NEURONS_HEIGHT-3): return []
    if (Col < 2): return []
    if (Col >= INPUT_NEURONS_WIDTH-3): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    endAddCol = Col+3
    for addCol in range (startAddCol,endAddCol):
        fromNeuronTwoBelow = ((Row+2)*50)+addCol
        fromNeuronBelow = ((Row+1)*50)+addCol
        fromNeuronSelf = ((Row)*50)+addCol
        newConnector = [(fromNeuronSelf, toNeuron, weight, DELAY),
                        (fromNeuronBelow, toNeuron, weight, DELAY),
                        (fromNeuronTwoBelow, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnector
    return connector


#----------setup connections 6x6off to HEdgeBottom (bottom of a solid)
#Two on either side and self, self and above, inhib below (10,5)
def set6x6OffToHEdgeTopConnections(Col,Row):
    weight = 3.0
    inhibWeight = -3.0
    #don't output off bottom
    if (Row < 1): return []
    if (Row >= INPUT_NEURONS_HEIGHT-2): return []
    if (Col < 2): return []
    if (Col >= INPUT_NEURONS_WIDTH-3): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    endAddCol = Col+3
    for addCol in range (startAddCol,endAddCol):
        fromNeuronAbove = ((Row-1)*50)+addCol
        fromNeuronSelf = ((Row)*50)+addCol
        fromNeuronBelow = ((Row+1)*50)+addCol
        newConnector = [(fromNeuronAbove, toNeuron, weight, DELAY),
                        (fromNeuronSelf, toNeuron, weight, DELAY),
                        (fromNeuronBelow, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 9x9off to HEdgeBottom (bottom of a solid)
#Two on either side and self, below and two below, inhib self(10,5)
def set9x9OffToHEdgeTopConnections(Col,Row):
    weight = 3.0
    inhibWeight = -3.0
    #don't output off bottom
    if (Row >= INPUT_NEURONS_HEIGHT-4): return []
    if (Col < 1): return []
    if (Col >= INPUT_NEURONS_WIDTH-2): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    endAddCol = Col+3
    for addCol in range (startAddCol,endAddCol):
        fromNeuronSelf = ((Row)*50)+addCol
        fromNeuronBelow = ((Row+1)*50)+addCol
        fromNeuronTwoBelow = ((Row+2)*50)+addCol
        newConnector = [(fromNeuronSelf, toNeuron, inhibWeight, DELAY),
                        (fromNeuronBelow, toNeuron, weight, DELAY),
                        (fromNeuronTwoBelow, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 6x6off to HEdgeTop (top of a solid)
#Two on either side and self, self and above, inhib two above (10,5)
def set6x6OnToHEdgeBottomConnections(Col,Row):
    weight = 3.0
    inhibWeight = -3.0
    #don't output off bottom
    if (Row < 3): return []
    if (Col < 1): return []
    if (Col >= INPUT_NEURONS_WIDTH-2): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    endAddCol = Col+3
    for addCol in range (startAddCol,endAddCol):
        fromNeuronTwoAbove = ((Row-2)*50)+addCol
        fromNeuronAbove = ((Row-1)*50)+addCol
        fromNeuronSelf = ((Row)*50)+addCol
        newConnector = [(fromNeuronTwoAbove, toNeuron, inhibWeight, DELAY),
                        (fromNeuronAbove, toNeuron, weight, DELAY),
                        (fromNeuronSelf, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 6x6off to HEdgeTop (top of a solid)
#Two on either side and self, self and below, inhib above (10,5)
def set6x6OffToHEdgeBottomConnections(Col,Row):
    weight = 3.0
    inhibWeight = -3.0
    #don't output off bottom
    if (Row < 1): return []
    if (Row >= INPUT_NEURONS_HEIGHT-2): return []
    if (Col < 1): return []
    if (Col >= INPUT_NEURONS_WIDTH-2): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    endAddCol = Col+3
    for addCol in range (startAddCol,endAddCol):
        fromNeuronAbove = ((Row-1)*50)+addCol
        fromNeuronSelf = ((Row)*50)+addCol
        fromNeuronBelow = ((Row+1)*50)+addCol
        newConnector = [(fromNeuronAbove, toNeuron, inhibWeight, DELAY),
                        (fromNeuronSelf, toNeuron, weight, DELAY),
                        (fromNeuronBelow, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#----------setup connections 9x9 off to HEdgeTop (top of a solid)
#Two on either side and self, inhib self and excite below two (10,5)
def set9x9OffToHEdgeBottomConnections(Col,Row):
    weight = 3.0
    inhibWeight = -3.0
    #don't output off bottom
    if (Row >= INPUT_NEURONS_HEIGHT-4): return []
    if (Col < 2): return []
    if (Col >= INPUT_NEURONS_WIDTH-3): return []
    connector = []
    toNeuron = (Row)*50+Col
    startAddCol = Col-2
    endAddCol = Col+3
    for addCol in range (startAddCol,endAddCol):
        fromNeuronSelf = ((Row)*50)+addCol
        fromNeuronBelow = ((Row+1)*50)+addCol
        fromNeuronTwoBelow = ((Row+2)*50)+addCol
        newConnector = [(fromNeuronSelf, toNeuron, inhibWeight, DELAY),
                        (fromNeuronBelow, toNeuron, weight, DELAY),
                        (fromNeuronTwoBelow, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector


#-------------set up connections from 3x3on to SEdgeRight/
#the right of a solid.  Have connections from four above through five below,
#sloping right rising 3/2.  Excite self and right, inhib two left. (20,10)
def set3x3OnToSEdgeRightConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 4): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-4): return []     #don't go off right

    weight = 3.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*-.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron -2, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector
    
#Set up connections from 3x3off to SEdgeRight/ the right of a solid.
#Have connections from four above through five below,
#sloping right as you go up.  Excite self and right, inhib two left. (20,10)
def set3x3OffToSEdgeRightConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 4): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-4): return []     #don't go off right

    weight = 4.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*-.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron -2, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector
    

#6x6on to SEdgeRight/ the right of a solid.  
#Have connections from four above through five below,
#sloping right as you go up.  Inhib self, excite right and two right (20,10).
def set6x6OnToSEdgeRightConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 2): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-6): return []     #don't go off right

    weight = 3.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*-.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron, toNeuron, inhibWeight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY),
                        (fromNeuron+2, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector

#----------setup connections 6x6 to SEdgeLeft (left of a solid)
#connections from self one to right then 3 above 2 below sloping
def set6x6OnToSEdgeLeftConnections(Col,Row):
    if (Row <3): return []
    if (Row > INPUT_NEURONS_HEIGHT -3): return []
    if (Col < 2): return []
    if (Col > INPUT_NEURONS_WIDTH -4): return []

    weight = 4.0
    inhibWeight = -4.0 # inhibit right sEdges well to the rigft
    toNeuron = (Row)*50+Col
    row1Off = (Row-3)*INPUT_NEURONS_WIDTH + Col+3
    row1Left = (Row-3)*INPUT_NEURONS_WIDTH + Col+2
    row1Right = (Row-3)*INPUT_NEURONS_WIDTH + Col+1
    row2Off = (Row-2)*INPUT_NEURONS_WIDTH + Col+2
    row2Left = (Row-2)*INPUT_NEURONS_WIDTH + Col+1
    row2Right = (Row-2)*INPUT_NEURONS_WIDTH + Col
    row3Off = (Row-1)*INPUT_NEURONS_WIDTH + Col+2
    row3Left = (Row-1)*INPUT_NEURONS_WIDTH + Col+1
    row3Right = (Row-1)*INPUT_NEURONS_WIDTH + Col
    ownRowOff = Row*INPUT_NEURONS_WIDTH + Col+1
    ownRowLeft = toNeuron
    ownRowRight = toNeuron - 1
    row5Off = (Row+1)*INPUT_NEURONS_WIDTH + Col+1
    row5Left = (Row+1)*INPUT_NEURONS_WIDTH + Col
    row5Right = (Row+1)*INPUT_NEURONS_WIDTH + Col-1
    row6Off = (Row+2)*INPUT_NEURONS_WIDTH + Col
    row6Left = (Row+2)*INPUT_NEURONS_WIDTH + Col-1
    row6Right = (Row+2)*INPUT_NEURONS_WIDTH + Col-2
    connector = [
        (row1Off, toNeuron, inhibWeight, DELAY),
        (row1Left, toNeuron, weight, DELAY),
        (row1Right, toNeuron, weight, DELAY),
        (row2Off, toNeuron, inhibWeight, DELAY),
        (row2Left, toNeuron, weight, DELAY),
        (row2Right, toNeuron, weight, DELAY),
        (row3Off, toNeuron, inhibWeight, DELAY),
        (row3Left, toNeuron, weight, DELAY),
        (row3Right, toNeuron, weight, DELAY),        
        (ownRowOff, toNeuron, inhibWeight, DELAY),
        (ownRowLeft, toNeuron, weight, DELAY),
        (ownRowRight, toNeuron, weight, DELAY),
        (row5Off, toNeuron, inhibWeight, DELAY),
        (row5Left, toNeuron, weight, DELAY),
        (row5Right, toNeuron, weight, DELAY),        
        (row6Off, toNeuron, inhibWeight, DELAY),
        (row6Left, toNeuron, weight, DELAY),
        (row6Right, toNeuron, weight, DELAY)]
    return connector

#-------------set up connections from 3x3on to BEdgeLeft \
#the left of a solid.  Have connections from four above through five below,
#sloping lef rising 3/2.  Excite left and self, inhib one right. (20,10)
def set3x3OnToBEdgeLeftConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 3): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-5): return []     #don't go off right

    weight = 2.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron -1, toNeuron, weight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnectors
    return connector
    
#-------------set up connections from 3x3off to BEdgeLeft \
#the left of a solid.  Have connections from four above through five below,
#sloping lef rising 3/2.  Excite two left  and left, inhib self. (20,10)
def set3x3OffToBEdgeLeftConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 3): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-5): return []     #don't go off right

    weight = 3.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron -2, toNeuron, weight, DELAY),
                        (fromNeuron-1, toNeuron, weight, DELAY),
                        (fromNeuron, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnectors
    return connector
    
#-------------set up connections from 6x6off to BEdgeLeft \
#the left of a solid.  Have connections from four above through five below,
#sloping left rising 3/2.  Excite self and right, inhib left. (20,10)
def set6x6OffToBEdgeLeftConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 3): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-5): return []     #don't go off right

    weight = 3.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector
    
#----------setup connections 3x3 on to BEdgeRight (right of a solid)
#-------------set up connections from 3x3on to BEdgeRight \
#the right of a solid.  Have connections from four above through five below,
#sloping left rising 3/2.  Excite right  and self, inhib left. (20,10)
def set3x3OnToBEdgeRightConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 3): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-5): return []     #don't go off right

    weight = 4.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector
    
#-------------set up connections from 3x3off to BEdgeRight \
#the right of a solid.  Have connections from four above through five below,
#sloping left rising 3/2.  Excite right  and self, inhib left. (20,10)
def set3x3OffToBEdgeRightConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 3): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-5): return []     #don't go off right

    weight = 4.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector
    
#-------------set up connections from 6x6off to BEdgeRight \
#the right of a solid.  Have connections from four above through five below,
#sloping left rising 3/2.  Excite self and left, inhib right. (20,10)
def set6x6OffToBEdgeRightConnections(Col,Row):
    if (Row < 4): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-7): return [] #don't go off bottom
    if (Col < 3): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-5): return []     #don't go off right

    weight = 4.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (-4,6):
        fromNeuron = ((Row+addRow)*50)+(Col)
        addCol = int(addRow*.67)
        fromNeuron = fromNeuron + addCol
        newConnectors = [(fromNeuron-1, toNeuron, weight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnectors
    return connector
    

#----------setup connections 3x3 on to And Angle 
#connections from self to own and above row and on either side for 6 in total
#inhibit below
def set3x3OnToAndAngleConnections(Col,Row):
    if (Row > INPUT_NEURONS_HEIGHT -2): return []
    if (Row < 1): return []
    if (Col < 1): return []
    if (Col > INPUT_NEURONS_WIDTH-2): return []

    weight = 5.0
    inhibWeight = -5.0

    toNeuron = (Row*50)+Col
    connector = [(toNeuron-INPUT_NEURONS_WIDTH-1,toNeuron,inhibWeight,DELAY),
                 (toNeuron-INPUT_NEURONS_WIDTH,toNeuron,inhibWeight,DELAY),
                 (toNeuron-INPUT_NEURONS_WIDTH+1,toNeuron,inhibWeight,DELAY)
                 ]
    for addRow in range (Row,Row+2):
      for addCol in range (Col-1,Col+2):
        fromNeuron = ((addRow)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    return connector

#setup connections 6x6 on to And Angle 
#connections from self to own and above rows and on either side for 6 in total
#inhib two below on either side (6,3)
def set6x6OnToAndAngleConnections(Col,Row):
    if (Row > INPUT_NEURONS_HEIGHT -2): return []
    if (Row < 2): return []
    if (Col < 1): return []
    if (Col > INPUT_NEURONS_WIDTH-2): return []

    weight = 4.0
    inhibWeight = -5.0

    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row,Row+2):
      for addCol in range (Col-1,Col+2):
        fromNeuron = ((addRow)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnector
    for addRow in range (Row-2,Row-1):
      for addCol in range (Col-1,Col+2):
        fromNeuron = ((addRow)*50)+addCol
        newConnector = [(fromNeuron, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnector
    return connector

#Connections from left, self and right, from  two above and above, inhib self
#(6,3)
def set9x9OnToAndAngleConnections(Col,Row):
    if (Row < 1): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-3): return [] #don't go off bottom
    if (Col < 1): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-2): return []     #don't go off right
    
    weight = 4.0
    inhibWeight = -4.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (Row-1,Row+1):
        fromNeuron = ((addRow)*50)+Col
        if (addRow == Row):
            connWeight = inhibWeight
        else:
            connWeight = weight
        newConnectors = [(fromNeuron -1, toNeuron, connWeight, DELAY),
                        (fromNeuron, toNeuron, connWeight, DELAY),
                        (fromNeuron+1, toNeuron, connWeight, DELAY)]
        connector = connector + newConnectors
    return connector

#-----setup connections 3x3 on to Less Than Angle 
#connections from self and two left self and two two below (9) one inhib right of that. (3)
def set3x3OnToLessThanAngleConnections(Col,Row):
    if (Row > INPUT_NEURONS_HEIGHT-4): return [] #don't go off bottom
    if (Col < 2): return []     #don't go off left

    weight = 6.0
    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row,Row+3):
        fromNeuron = ((addRow)*50)+Col
        newConnectors = [(fromNeuron -1, toNeuron, weight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector

#connect 6x6off from self and one one right self and two below (6) one inhib right of that. (3)
def set6x6OffToLessThanAngleConnections(Col,Row):
    if (Row > INPUT_NEURONS_HEIGHT-4): return [] #don't go off bottom
    if (Col < 1): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH -2): return []     #don't go off right

    weight = 5.0
    inhibWeight = -10.0
    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row,Row+3):
        fromNeuron = ((addRow)*50)+Col
        newConnectors = [(fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector

#connect 9x9on from one left self and two below(4) one inhib right of that(2).
def set9x9OnToLessThanAngleConnections(Col,Row):
    if (Row < 2): return [] #don't go off bottom
    if (Col < 1): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-1): return []     #don't go off right

    weight = 6.0
    inhibWeight = -6.0
    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row-3,Row-1):
        fromNeuron = ((addRow)*50)+Col
        newConnectors = [(fromNeuron-1, toNeuron, inhibWeight, DELAY),
                        (fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY)]
        connector = connector + newConnectors
    return connector

#----------setup connections 3x3 on to Greater Than Angle 
#conns from self and two right above and below (9)
def set3x3OnToGreaterThanAngleConnections(Col,Row):
    if (Row < 1): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-2): return [] #don't go off bottom
    if (Col > INPUT_NEURONS_WIDTH-3): return [] #don't go off right

    weight = 9.0

    toNeuron = (Row*50)+Col
    connector =  []
    for addRow in range (Row-1,Row+2):
        fromNeuron = ((addRow)*50)+Col
        newConnector = [(fromNeuron, toNeuron, weight, DELAY),
                        (fromNeuron+1, toNeuron, weight, DELAY),
                        (fromNeuron+2, toNeuron, weight, DELAY)
                        ]
        connector = connector + newConnector
    return connector

#connect 6x6off connect two to right inhib self two rows above (4,2)
def set6x6OffToGreaterThanAngleConnections(Col,Row):
    if (Row > INPUT_NEURONS_HEIGHT-3): return []     #don't go off bottom
    if (Col < 2): return [] #don't go off left

    weight = 4.0
    inhibWeight = -9.0
    toNeuron = (Row*50)+Col
    connector =  []
    for addRow in range (Row+1,Row+3):
        fromNeuron = ((addRow)*50)+Col
        newConnector = [(fromNeuron, toNeuron, inhibWeight, DELAY),
                        (fromNeuron-1, toNeuron, weight, DELAY),
                        (fromNeuron-2, toNeuron, weight, DELAY)
                        ]
        connector = connector + newConnector
    return connector


#connect 9x9on from left two, inhib from self two rows above (4,2)
def set9x9OnToGreaterThanAngleConnections(Col,Row):
    if (Row < 3): return [] #don't go off top
    if (Col < 2): return [] #don't go off left

    weight = 4.0
    inhibWeight = -9.0

    toNeuron = (Row*50)+Col
    connector = []
    for addRow in range (Row-2,Row):
        fromNeuron = ((addRow)*50)+Col
        newConnectors = [(fromNeuron-2, toNeuron, weight, DELAY),
                        (fromNeuron-1, toNeuron, weight, DELAY),
                        (fromNeuron, toNeuron, inhibWeight, DELAY)]
        connector = connector + newConnectors
    return connector


#---------Connections for Stalactite V1 detectors
#hedgesTop on top
#sedge right on top
#bedge left on top

#----------setup connections 3x3 on to or angle
#Connections from left, self and right, from above,self and down one,
#inhib one more down(9,3)
def set3x3OnToOrAngleConnections(Col,Row):
    if (Row < 1): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-4): return [] #don't go off bottom
    if (Col < 1): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-2): return []     #don't go off right
    
    weight = 7.0
    inhibWeight = -9.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (Row-1,Row+3):
        fromNeuron = ((addRow)*50)+Col
        if (addRow == Row +2):
            connWeight = inhibWeight
        else:
            connWeight = weight
        newConnectors = [(fromNeuron -1, toNeuron, connWeight, DELAY),
                        (fromNeuron, toNeuron, connWeight, DELAY),
                        (fromNeuron+1, toNeuron, connWeight, DELAY)]
        connector = connector + newConnectors
    return connector


#----------setup connections 6x6 on to or angle
#Connections from left, self and right, from two above, inhib own row (6,3)
def set6x6OnToOrAngleConnections(Col,Row):
    if (Row < 1): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-3): return [] #don't go off bottom
    if (Col < 1): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-2): return []     #don't go off right
    
    weight = 3.0
    inhibWeight = -3.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (Row-2,Row+1):
        fromNeuron = ((addRow)*50)+Col
        if (addRow == Row):
            connWeight = inhibWeight
        else:
            connWeight = weight
        newConnectors = [(fromNeuron -1, toNeuron, connWeight, DELAY),
                        (fromNeuron, toNeuron, connWeight, DELAY),
                        (fromNeuron+1, toNeuron, connWeight, DELAY)]
        connector = connector + newConnectors
    return connector


#Connections from left, self and right, from  two above and above, inhib self
#(6,3)
def set6x6OffToOrAngleConnections(Col,Row):
    if (Row < 1): return [] #don't go off top
    if (Row > INPUT_NEURONS_HEIGHT-3): return [] #don't go off bottom
    if (Col < 1): return []     #don't go off left
    if (Col > INPUT_NEURONS_WIDTH-2): return []     #don't go off right
    
    weight = 3.0
    inhibWeight = -3.0
    toNeuron = (Row)*50+Col
    connector = []
    for addRow in range (Row-1,Row+1):
        fromNeuron = ((addRow)*50)+Col
        if (addRow == Row):
            connWeight = inhibWeight
        else:
            connWeight = weight
        newConnectors = [(fromNeuron -1, toNeuron, connWeight, DELAY),
                        (fromNeuron, toNeuron, connWeight, DELAY),
                        (fromNeuron+1, toNeuron, connWeight, DELAY)]
        connector = connector + newConnectors
    return connector

